import React, { Component } from 'react';
import PropTypes from 'prop-types';

export const DOT_INTERVAL = 300;

export class DotPreloader extends Component {
  static propTypes = {
    className: PropTypes.string,
  };

  static defaultProps = {
    className: '',
  };

  state = {
    text: '.',
  };

  dotsInterval;

  componentDidMount() {
    this.dotsInterval = setInterval(this.addDot, DOT_INTERVAL);
  }

  componentWillUnmount() {
    clearInterval(this.dotsInterval);
  }

  addDot = () => {
    const { text } = this.state;

    if (text.length > 2) {
      this.setState({ text: '.' });
    } else {
      this.setState({ text: `${text}.` });
    }
  }

  render() {
    const { text } = this.state;
    const { className } = this.props;

    return (
      <span className={className}>{text}</span>
    );
  }
}
