import React from 'react';

import { DotPreloader } from './dot-preloader';

jest.useFakeTimers();

describe('<DotPreloader />', () => {
  const { setInterval, clearInterval } = window;
  const wrapper = shallow(<DotPreloader />);

  test('should match snapshot', () => {
    expect(wrapper).toMatchSnapshot();
  });

  test('componentDidMount', () => {
    expect(setInterval).toHaveBeenCalledTimes(1);
  });

  test('addDot', () => {
    expect(wrapper.instance().state.text).toEqual('.');
    wrapper.instance().addDot();
    expect(wrapper.instance().state.text).toEqual('..');
    wrapper.instance().addDot();
    expect(wrapper.instance().state.text).toEqual('...');
    wrapper.instance().addDot();
    expect(wrapper.instance().state.text).toEqual('.');
  });

  test('componentWillUnmount', () => {
    wrapper.instance().componentWillUnmount();
    expect(clearInterval).toHaveBeenCalledTimes(1);
  });
});
